/* Settings.c generated by valac 0.56.13, the Vala compiler
 * generated from Settings.vala, do not modify */

/* Settings.vala
 *
 * The following code is a derivative work of the code from
 * https://github.com/elementary/granite/blob/master/lib/Services/Settings.vala
 * which is licensed under GNU Lesser General Public version 3 of the License,
 * or (at your option) any later version.
 *
 * Copyright 2020-2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "pqmarble.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

enum  {
	PQ_MARBLE_SETTINGS_0_PROPERTY,
	PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY,
	PQ_MARBLE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* pq_marble_settings_properties[PQ_MARBLE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PQMarbleSettingsPrivate {
	GSettings* _schema;
	gboolean updating;
	gboolean doing_setup;
};

static gint PQMarbleSettings_private_offset;
static gpointer pq_marble_settings_parent_class = NULL;

static void pq_marble_settings_load_key (PQMarbleSettings* self,
                                  const gchar* key);
static void pq_marble_settings_on_notify (PQMarbleSettings* self,
                                   GObject* sender,
                                   GParamSpec* prop);
static void _pq_marble_settings_on_notify_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void pq_marble_settings_save_key (PQMarbleSettings* self,
                                  const gchar* key);
static GObject * pq_marble_settings_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _pq_marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                                      const gchar* key,
                                                      gpointer self);
static void pq_marble_settings_finalize (GObject * obj);
static GType pq_marble_settings_get_type_once (void);
static void _vala_pq_marble_settings_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_pq_marble_settings_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
pq_marble_settings_get_instance_private (PQMarbleSettings* self)
{
	return G_STRUCT_MEMBER_P (self, PQMarbleSettings_private_offset);
}

PQMarbleSettings*
pq_marble_settings_construct (GType object_type,
                              const gchar* path)
{
	PQMarbleSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = g_settings_new (path);
	_tmp1_ = _tmp0_;
	self = (PQMarbleSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

static gpointer
_g_param_spec_ref0 (gpointer self)
{
	return self ? g_param_spec_ref (self) : NULL;
}

static void
_pq_marble_settings_on_notify_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	pq_marble_settings_on_notify ((PQMarbleSettings*) self, _sender, pspec);
}

static void
pq_marble_settings_load_key (PQMarbleSettings* self,
                             const gchar* key)
{
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp0_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	guint _tmp5_;
	GType type = 0UL;
	GParamSpec* _tmp6_;
	GValue val = {0};
	GValue _tmp7_ = {0};
	GParamSpec* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "schema") == 0) {
		return;
	}
	_tmp0_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
	obj_class = (GObjectClass*) _tmp0_;
	_tmp1_ = obj_class;
	_tmp2_ = g_object_class_find_property (_tmp1_, key);
	_tmp3_ = _g_param_spec_ref0 (_tmp2_);
	prop = _tmp3_;
	_tmp4_ = prop;
	if (_tmp4_ == NULL) {
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _pq_marble_settings_on_notify_g_object_notify, self);
	_tmp6_ = prop;
	type = _tmp6_->value_type;
	g_value_init (&_tmp7_, type);
	val = _tmp7_;
	g_object_get_property ((GObject*) self, key, &val);
	_tmp8_ = prop;
	if (G_VALUE_TYPE (&val) != _tmp8_->value_type) {
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp9_ = g_strdup_printf ("%lu", (gulong) type);
		_tmp10_ = _tmp9_;
		g_warning ("Settings.vala:71: Unsupported type %s for key %s", _tmp10_, key);
		_g_free0 (_tmp10_);
		g_signal_connect_object ((GObject*) self, "notify", (GCallback) _pq_marble_settings_on_notify_g_object_notify, self, 0);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	if (type == G_TYPE_INT) {
		GParamSpec* _tmp11_;
		const gchar* _tmp12_;
		GSettings* _tmp13_;
		GValue _tmp14_ = {0};
		_tmp11_ = prop;
		_tmp12_ = _tmp11_->name;
		_tmp13_ = self->priv->_schema;
		g_value_init (&_tmp14_, G_TYPE_INT);
		g_value_set_int (&_tmp14_, g_settings_get_int (_tmp13_, key));
		g_object_set_property ((GObject*) self, _tmp12_, &_tmp14_);
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
	} else {
		if (type == G_TYPE_UINT) {
			GParamSpec* _tmp15_;
			const gchar* _tmp16_;
			GSettings* _tmp17_;
			GValue _tmp18_ = {0};
			_tmp15_ = prop;
			_tmp16_ = _tmp15_->name;
			_tmp17_ = self->priv->_schema;
			g_value_init (&_tmp18_, G_TYPE_UINT);
			g_value_set_uint (&_tmp18_, g_settings_get_uint (_tmp17_, key));
			g_object_set_property ((GObject*) self, _tmp16_, &_tmp18_);
			G_IS_VALUE (&_tmp18_) ? (g_value_unset (&_tmp18_), NULL) : NULL;
		} else {
			if (type == G_TYPE_DOUBLE) {
				GParamSpec* _tmp19_;
				const gchar* _tmp20_;
				GSettings* _tmp21_;
				GValue _tmp22_ = {0};
				_tmp19_ = prop;
				_tmp20_ = _tmp19_->name;
				_tmp21_ = self->priv->_schema;
				g_value_init (&_tmp22_, G_TYPE_DOUBLE);
				g_value_set_double (&_tmp22_, g_settings_get_double (_tmp21_, key));
				g_object_set_property ((GObject*) self, _tmp20_, &_tmp22_);
				G_IS_VALUE (&_tmp22_) ? (g_value_unset (&_tmp22_), NULL) : NULL;
			} else {
				if (type == G_TYPE_BOOLEAN) {
					GParamSpec* _tmp23_;
					const gchar* _tmp24_;
					GSettings* _tmp25_;
					GValue _tmp26_ = {0};
					_tmp23_ = prop;
					_tmp24_ = _tmp23_->name;
					_tmp25_ = self->priv->_schema;
					g_value_init (&_tmp26_, G_TYPE_BOOLEAN);
					g_value_set_boolean (&_tmp26_, g_settings_get_boolean (_tmp25_, key));
					g_object_set_property ((GObject*) self, _tmp24_, &_tmp26_);
					G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
				} else {
					if (type == G_TYPE_STRING) {
						GParamSpec* _tmp27_;
						const gchar* _tmp28_;
						GSettings* _tmp29_;
						gchar* _tmp30_;
						GValue _tmp31_ = {0};
						_tmp27_ = prop;
						_tmp28_ = _tmp27_->name;
						_tmp29_ = self->priv->_schema;
						_tmp30_ = g_settings_get_string (_tmp29_, key);
						g_value_init (&_tmp31_, G_TYPE_STRING);
						g_value_take_string (&_tmp31_, _tmp30_);
						g_object_set_property ((GObject*) self, _tmp28_, &_tmp31_);
						G_IS_VALUE (&_tmp31_) ? (g_value_unset (&_tmp31_), NULL) : NULL;
					} else {
						if (type == G_TYPE_STRV) {
							GParamSpec* _tmp32_;
							const gchar* _tmp33_;
							GSettings* _tmp34_;
							gchar** _tmp35_;
							gchar** _tmp36_;
							GValue _tmp37_ = {0};
							_tmp32_ = prop;
							_tmp33_ = _tmp32_->name;
							_tmp34_ = self->priv->_schema;
							_tmp36_ = _tmp35_ = g_settings_get_strv (_tmp34_, key);
							g_value_init (&_tmp37_, G_TYPE_STRV);
							g_value_take_boxed (&_tmp37_, _tmp36_);
							g_object_set_property ((GObject*) self, _tmp33_, &_tmp37_);
							G_IS_VALUE (&_tmp37_) ? (g_value_unset (&_tmp37_), NULL) : NULL;
						} else {
							if (type == G_TYPE_INT64) {
								GParamSpec* _tmp38_;
								const gchar* _tmp39_;
								GSettings* _tmp40_;
								GVariant* _tmp41_;
								GVariant* _tmp42_;
								GValue _tmp43_ = {0};
								_tmp38_ = prop;
								_tmp39_ = _tmp38_->name;
								_tmp40_ = self->priv->_schema;
								_tmp41_ = g_settings_get_value (_tmp40_, key);
								_tmp42_ = _tmp41_;
								g_value_init (&_tmp43_, G_TYPE_INT64);
								g_value_set_int64 (&_tmp43_, g_variant_get_int64 (_tmp42_));
								g_object_set_property ((GObject*) self, _tmp39_, &_tmp43_);
								G_IS_VALUE (&_tmp43_) ? (g_value_unset (&_tmp43_), NULL) : NULL;
								_g_variant_unref0 (_tmp42_);
							} else {
								if (type == G_TYPE_UINT64) {
									GParamSpec* _tmp44_;
									const gchar* _tmp45_;
									GSettings* _tmp46_;
									GVariant* _tmp47_;
									GVariant* _tmp48_;
									GValue _tmp49_ = {0};
									_tmp44_ = prop;
									_tmp45_ = _tmp44_->name;
									_tmp46_ = self->priv->_schema;
									_tmp47_ = g_settings_get_value (_tmp46_, key);
									_tmp48_ = _tmp47_;
									g_value_init (&_tmp49_, G_TYPE_UINT64);
									g_value_set_uint64 (&_tmp49_, g_variant_get_uint64 (_tmp48_));
									g_object_set_property ((GObject*) self, _tmp45_, &_tmp49_);
									G_IS_VALUE (&_tmp49_) ? (g_value_unset (&_tmp49_), NULL) : NULL;
									_g_variant_unref0 (_tmp48_);
								} else {
									if (G_TYPE_IS_ENUM (type)) {
										GParamSpec* _tmp50_;
										const gchar* _tmp51_;
										GSettings* _tmp52_;
										GValue _tmp53_ = {0};
										_tmp50_ = prop;
										_tmp51_ = _tmp50_->name;
										_tmp52_ = self->priv->_schema;
										g_value_init (&_tmp53_, G_TYPE_INT);
										g_value_set_int (&_tmp53_, g_settings_get_enum (_tmp52_, key));
										g_object_set_property ((GObject*) self, _tmp51_, &_tmp53_);
										G_IS_VALUE (&_tmp53_) ? (g_value_unset (&_tmp53_), NULL) : NULL;
									} else {
										if (type == G_TYPE_VARIANT) {
											GParamSpec* _tmp54_;
											const gchar* _tmp55_;
											GSettings* _tmp56_;
											GVariant* _tmp57_;
											GValue _tmp58_ = {0};
											_tmp54_ = prop;
											_tmp55_ = _tmp54_->name;
											_tmp56_ = self->priv->_schema;
											_tmp57_ = g_settings_get_value (_tmp56_, key);
											g_value_init (&_tmp58_, G_TYPE_VARIANT);
											g_value_take_variant (&_tmp58_, _tmp57_);
											g_object_set_property ((GObject*) self, _tmp55_, &_tmp58_);
											G_IS_VALUE (&_tmp58_) ? (g_value_unset (&_tmp58_), NULL) : NULL;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _pq_marble_settings_on_notify_g_object_notify, self, 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_param_spec_unref0 (prop);
	_g_type_class_unref0 (obj_class);
}

static void
pq_marble_settings_save_key (PQMarbleSettings* self,
                             const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp1_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	GParamSpec* _tmp5_;
	guint _tmp6_;
	gboolean res = FALSE;
	GType type = 0UL;
	GParamSpec* _tmp7_;
	GValue val = {0};
	GValue _tmp8_ = {0};
	GParamSpec* _tmp9_;
	const gchar* _tmp10_;
	GParamSpec* _tmp11_;
	gboolean _tmp14_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "schema") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->updating;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
	obj_class = (GObjectClass*) _tmp1_;
	_tmp2_ = obj_class;
	_tmp3_ = g_object_class_find_property (_tmp2_, key);
	_tmp4_ = _g_param_spec_ref0 (_tmp3_);
	prop = _tmp4_;
	_tmp5_ = prop;
	if (_tmp5_ == NULL) {
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp6_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _pq_marble_settings_on_notify_g_object_notify, self);
	res = TRUE;
	self->priv->updating = TRUE;
	_tmp7_ = prop;
	type = _tmp7_->value_type;
	g_value_init (&_tmp8_, type);
	val = _tmp8_;
	_tmp9_ = prop;
	_tmp10_ = _tmp9_->name;
	g_object_get_property ((GObject*) self, _tmp10_, &val);
	_tmp11_ = prop;
	if (G_VALUE_TYPE (&val) != _tmp11_->value_type) {
		gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp12_ = g_strdup_printf ("%lu", (gulong) type);
		_tmp13_ = _tmp12_;
		g_warning ("Settings.vala:136: Unsupported type %s for key %s", _tmp13_, key);
		_g_free0 (_tmp13_);
	}
	if (type == G_TYPE_INT) {
		GSettings* _tmp15_;
		_tmp15_ = self->priv->_schema;
		_tmp14_ = g_value_get_int (&val) != g_settings_get_int (_tmp15_, key);
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		GSettings* _tmp16_;
		_tmp16_ = self->priv->_schema;
		res = g_settings_set_int (_tmp16_, key, g_value_get_int (&val));
	} else {
		gboolean _tmp17_ = FALSE;
		if (type == G_TYPE_UINT) {
			GSettings* _tmp18_;
			_tmp18_ = self->priv->_schema;
			_tmp17_ = g_value_get_uint (&val) != g_settings_get_uint (_tmp18_, key);
		} else {
			_tmp17_ = FALSE;
		}
		if (_tmp17_) {
			GSettings* _tmp19_;
			_tmp19_ = self->priv->_schema;
			res = g_settings_set_uint (_tmp19_, key, g_value_get_uint (&val));
		} else {
			gboolean _tmp20_ = FALSE;
			if (type == G_TYPE_DOUBLE) {
				GSettings* _tmp21_;
				_tmp21_ = self->priv->_schema;
				_tmp20_ = g_value_get_double (&val) != g_settings_get_double (_tmp21_, key);
			} else {
				_tmp20_ = FALSE;
			}
			if (_tmp20_) {
				GSettings* _tmp22_;
				_tmp22_ = self->priv->_schema;
				res = g_settings_set_double (_tmp22_, key, g_value_get_double (&val));
			} else {
				gboolean _tmp23_ = FALSE;
				if (type == G_TYPE_BOOLEAN) {
					GSettings* _tmp24_;
					_tmp24_ = self->priv->_schema;
					_tmp23_ = g_value_get_boolean (&val) != g_settings_get_boolean (_tmp24_, key);
				} else {
					_tmp23_ = FALSE;
				}
				if (_tmp23_) {
					GSettings* _tmp25_;
					_tmp25_ = self->priv->_schema;
					res = g_settings_set_boolean (_tmp25_, key, g_value_get_boolean (&val));
				} else {
					gboolean _tmp26_ = FALSE;
					if (type == G_TYPE_STRING) {
						const gchar* _tmp27_;
						GSettings* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						_tmp27_ = g_value_get_string (&val);
						_tmp28_ = self->priv->_schema;
						_tmp29_ = g_settings_get_string (_tmp28_, key);
						_tmp30_ = _tmp29_;
						_tmp26_ = g_strcmp0 (_tmp27_, _tmp30_) != 0;
						_g_free0 (_tmp30_);
					} else {
						_tmp26_ = FALSE;
					}
					if (_tmp26_) {
						GSettings* _tmp31_;
						const gchar* _tmp32_;
						_tmp31_ = self->priv->_schema;
						_tmp32_ = g_value_get_string (&val);
						res = g_settings_set_string (_tmp31_, key, _tmp32_);
					} else {
						if (type == G_TYPE_STRV) {
							gchar** strv = NULL;
							gint strv_length1;
							gint _strv_size_;
							gchar** _tmp33_;
							gint _tmp33__length1;
							GSettings* _tmp34_;
							gchar** _tmp35_;
							gchar** _tmp36_;
							gchar** _tmp37_;
							gint _tmp37__length1;
							gboolean _tmp38_;
							strv = NULL;
							strv_length1 = 0;
							_strv_size_ = strv_length1;
							g_object_get ((GObject*) self, key, &strv, NULL);
							_tmp33_ = strv;
							_tmp33__length1 = strv_length1;
							_tmp34_ = self->priv->_schema;
							_tmp36_ = _tmp35_ = g_settings_get_strv (_tmp34_, key);
							_tmp37_ = _tmp36_;
							_tmp37__length1 = _vala_array_length (_tmp35_);
							_tmp38_ = _tmp33_ != _tmp37_;
							_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
							if (_tmp38_) {
								GSettings* _tmp39_;
								gchar** _tmp40_;
								gint _tmp40__length1;
								_tmp39_ = self->priv->_schema;
								_tmp40_ = strv;
								_tmp40__length1 = strv_length1;
								res = g_settings_set_strv (_tmp39_, key, _tmp40_);
							}
							strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
						} else {
							gboolean _tmp41_ = FALSE;
							if (type == G_TYPE_INT64) {
								GSettings* _tmp42_;
								GVariant* _tmp43_;
								GVariant* _tmp44_;
								_tmp42_ = self->priv->_schema;
								_tmp43_ = g_settings_get_value (_tmp42_, key);
								_tmp44_ = _tmp43_;
								_tmp41_ = g_value_get_int64 (&val) != g_variant_get_int64 (_tmp44_);
								_g_variant_unref0 (_tmp44_);
							} else {
								_tmp41_ = FALSE;
							}
							if (_tmp41_) {
								GSettings* _tmp45_;
								GVariant* _tmp46_;
								GVariant* _tmp47_;
								_tmp45_ = self->priv->_schema;
								_tmp46_ = g_variant_new_int64 (g_value_get_int64 (&val));
								g_variant_ref_sink (_tmp46_);
								_tmp47_ = _tmp46_;
								res = g_settings_set_value (_tmp45_, key, _tmp47_);
								_g_variant_unref0 (_tmp47_);
							} else {
								gboolean _tmp48_ = FALSE;
								if (type == G_TYPE_UINT64) {
									GSettings* _tmp49_;
									GVariant* _tmp50_;
									GVariant* _tmp51_;
									_tmp49_ = self->priv->_schema;
									_tmp50_ = g_settings_get_value (_tmp49_, key);
									_tmp51_ = _tmp50_;
									_tmp48_ = g_value_get_uint64 (&val) != g_variant_get_uint64 (_tmp51_);
									_g_variant_unref0 (_tmp51_);
								} else {
									_tmp48_ = FALSE;
								}
								if (_tmp48_) {
									GSettings* _tmp52_;
									GVariant* _tmp53_;
									GVariant* _tmp54_;
									_tmp52_ = self->priv->_schema;
									_tmp53_ = g_variant_new_uint64 (g_value_get_uint64 (&val));
									g_variant_ref_sink (_tmp53_);
									_tmp54_ = _tmp53_;
									res = g_settings_set_value (_tmp52_, key, _tmp54_);
									_g_variant_unref0 (_tmp54_);
								} else {
									gboolean _tmp55_ = FALSE;
									if (G_TYPE_IS_ENUM (type)) {
										GSettings* _tmp56_;
										_tmp56_ = self->priv->_schema;
										_tmp55_ = g_value_get_enum (&val) != g_settings_get_enum (_tmp56_, key);
									} else {
										_tmp55_ = FALSE;
									}
									if (_tmp55_) {
										GSettings* _tmp57_;
										_tmp57_ = self->priv->_schema;
										res = g_settings_set_enum (_tmp57_, key, g_value_get_enum (&val));
									} else {
										if (type == G_TYPE_VARIANT) {
											GSettings* _tmp58_;
											GVariant* _tmp59_;
											GVariant* _tmp60_;
											_tmp58_ = self->priv->_schema;
											_tmp59_ = g_value_get_variant (&val);
											_tmp60_ = _tmp59_;
											res = g_settings_set_value (_tmp58_, key, _tmp60_);
											_g_variant_unref0 (_tmp60_);
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	if (!res) {
		g_warning ("Settings.vala:202: Could not update %s", key);
	}
	self->priv->updating = FALSE;
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _pq_marble_settings_on_notify_g_object_notify, self, 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_param_spec_unref0 (prop);
	_g_type_class_unref0 (obj_class);
}

static void
pq_marble_settings_on_notify (PQMarbleSettings* self,
                              GObject* sender,
                              GParamSpec* prop)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (prop != NULL);
	_tmp0_ = prop->name;
	pq_marble_settings_save_key (self, _tmp0_);
}

GSettings*
pq_marble_settings_get_schema (PQMarbleSettings* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_schema;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
pq_marble_settings_set_schema (PQMarbleSettings* self,
                               GSettings* value)
{
	GSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = pq_marble_settings_get_schema (self);
	if (old_value != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_schema);
		self->priv->_schema = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pq_marble_settings_properties[PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY]);
	}
}

static void
_pq_marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                                 const gchar* key,
                                                 gpointer self)
{
	pq_marble_settings_load_key ((PQMarbleSettings*) self, key);
}

static GObject *
pq_marble_settings_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PQMarbleSettings * self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp4_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp5_;
	guint _tmp6_ = 0;
	GParamSpec** _tmp7_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp8_;
	gint _tmp8__length1;
	GSettings* _tmp11_;
	parent_class = G_OBJECT_CLASS (pq_marble_settings_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
	_tmp0_ = self->priv->_schema;
	g_object_get (_tmp0_, "schema-id", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	g_debug ("Settings.vala:38: Started settings from '%s'", _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
	obj_class = (GObjectClass*) _tmp4_;
	_tmp5_ = obj_class;
	_tmp7_ = g_object_class_list_properties (_tmp5_, &_tmp6_);
	properties = _tmp7_;
	properties_length1 = _tmp6_;
	_properties_size_ = properties_length1;
	_tmp8_ = properties;
	_tmp8__length1 = properties_length1;
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
		prop_collection = _tmp8_;
		prop_collection_length1 = _tmp8__length1;
		for (prop_it = 0; prop_it < prop_collection_length1; prop_it = prop_it + 1) {
			GParamSpec* prop = NULL;
			prop = prop_collection[prop_it];
			{
				GParamSpec* _tmp9_;
				const gchar* _tmp10_;
				_tmp9_ = prop;
				_tmp10_ = _tmp9_->name;
				pq_marble_settings_load_key (self, _tmp10_);
			}
		}
	}
	self->priv->doing_setup = FALSE;
	_tmp11_ = self->priv->_schema;
	g_signal_connect_object (_tmp11_, "changed", (GCallback) _pq_marble_settings_load_key_g_settings_changed, self, 0);
	properties = (g_free (properties), NULL);
	_g_type_class_unref0 (obj_class);
	return obj;
}

static void
pq_marble_settings_class_init (PQMarbleSettingsClass * klass,
                               gpointer klass_data)
{
	pq_marble_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PQMarbleSettings_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pq_marble_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pq_marble_settings_set_property;
	G_OBJECT_CLASS (klass)->constructor = pq_marble_settings_constructor;
	G_OBJECT_CLASS (klass)->finalize = pq_marble_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY, pq_marble_settings_properties[PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY] = g_param_spec_object ("schema", "schema", "schema", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
pq_marble_settings_instance_init (PQMarbleSettings * self,
                                  gpointer klass)
{
	self->priv = pq_marble_settings_get_instance_private (self);
	self->priv->updating = FALSE;
	self->priv->doing_setup = TRUE;
}

static void
pq_marble_settings_finalize (GObject * obj)
{
	PQMarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
	_g_object_unref0 (self->priv->_schema);
	G_OBJECT_CLASS (pq_marble_settings_parent_class)->finalize (obj);
}

static GType
pq_marble_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PQMarbleSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pq_marble_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PQMarbleSettings), 0, (GInstanceInitFunc) pq_marble_settings_instance_init, NULL };
	GType pq_marble_settings_type_id;
	pq_marble_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "PQMarbleSettings", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PQMarbleSettings_private_offset = g_type_add_instance_private (pq_marble_settings_type_id, sizeof (PQMarbleSettingsPrivate));
	return pq_marble_settings_type_id;
}

GType
pq_marble_settings_get_type (void)
{
	static volatile gsize pq_marble_settings_type_id__once = 0;
	if (g_once_init_enter (&pq_marble_settings_type_id__once)) {
		GType pq_marble_settings_type_id;
		pq_marble_settings_type_id = pq_marble_settings_get_type_once ();
		g_once_init_leave (&pq_marble_settings_type_id__once, pq_marble_settings_type_id);
	}
	return pq_marble_settings_type_id__once;
}

static void
_vala_pq_marble_settings_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	PQMarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
	switch (property_id) {
		case PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY:
		g_value_set_object (value, pq_marble_settings_get_schema (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pq_marble_settings_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	PQMarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
	switch (property_id) {
		case PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY:
		pq_marble_settings_set_schema (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

